function [] = loadArtoaIni(~, ~)
%RELOADARTOAINI Loads the artoa.ini file and copies the required values to workspace.
%   

global artoaConfig artoaWorkspace;

try
    artoaConfig = artoa.load.tomlini('artoa.ini');
    artoaWorkspace.soundsourceColors = artoaConfig.soundsourcecolors./255;
    artoaWorkspace.soundsourceColorRegister = artoa.soundsources.colorregister.create();
catch ex
    error([mfilename ': Reading artoa.ini failed with the following message: ' ex.message]);
end

if isempty(artoaConfig)
    error([mfilename ': artoa.ini has been found but is empty. Please use a valid artoa.ini!']);
end

artoa.controller.addDefaults();

artoa.controller.edit.updateAvailablePlots();


end

